class BN  expands Mutator;

var bool initialized;
var scriptedpawn      sp;
var int               monstertype;
var vector            loc;
var int               spreetype;
var string            mn;
var vector            stack_loc[10];
var int               stack_spree[10];
var int               stack_point;


// 
// this function is never called, is just here to precache stuff and kill "spawn lag" (works fine !) 
//
function NobodyEverCallsMe()
{
sp = spawn(class'unreali.Queen',,, loc);     
sp = spawn(class'unreali.Warlord',,, loc);     
sp = spawn(class'unreali.SkaarjBerserker',,, loc);     
sp = spawn(class'unreali.SkaarjScout',,, loc);
sp = spawn(class'unreali.SkaarjWarrior',,, loc);
sp = spawn(class'unreali.SkaarjAssassin',,, loc);
sp = spawn(class'unreali.SkaarjLord',,, loc);
sp = spawn(class'unreali.SkaarjBerserker',,, loc);
sp = spawn(class'unreali.SkaarjSniper',,, loc);
sp = spawn(class'unreali.SkaarjTrooper',,, loc);
sp = spawn(class'unreali.SkaarjInfantry',,, loc);
sp = spawn(class'unreali.SkaarjGunner',,, loc);
sp = spawn(class'unreali.SkaarjOfficer',,, loc);
sp = spawn(class'unreali.GiantManta',,, loc);
sp = spawn(class'unreali.KrallElite',,, loc);     
sp = spawn(class'unreali.MercenaryElite',,, loc);
sp = spawn(class'unreali.Krall',,, loc);
sp = spawn(class'unreali.Mercenary',,, loc);
sp = spawn(class'unreali.Slith',,, loc);
sp = spawn(class'unreali.Titan',,, loc);
sp = spawn(class'unreali.StoneTitan',,, loc);     
sp = spawn(class'unreali.Fly',,, loc);
sp = spawn(class'unreali.Manta',,, loc);     
sp = spawn(class'unreali.Brute',,, loc);
sp = spawn(class'unreali.Cow',,, loc);
sp = spawn(class'unreali.Pupae',,, loc);
}

function PostBeginPlay()
{
     if (Initialized)
          return;
     Initialized = True;
     log("*** Initializing BadNews!");
     Level.Game.RegisterDamageMutator( Self );
     Super.PostBeginPlay();
}

function ScoreKill(Pawn Killer, Pawn Other)
{
     local string deathmsg;

  if (Killer != None)
  {
     if ((Other.isA('PlayerPawn') || Other.isA('Bot'))  && (Killer.isA('PlayerPawn') || Killer.isA('Bot') || Killer.isA('ScriptedPawn'))  )
     {
          if (Other.spree > 4)
          {
               stack_push(Other.Spree,Other.Location);
               setTimer(1,false);
          }
     }
     if (Other.isA('ScriptedPawn') && (Killer.isA('PlayerPawn') || Killer.isA('Bot')) )
     {
	  deathmsg=dmsg();
          if (Other.isA('Queen') || Other.isA('Titan') || Other.isA('StoneTitan'))
          {
               Killer.playerreplicationinfo.score += 4;
               BroadcastMessage( Killer.PlayerReplicationInfo.PlayerName@deathmsg@Other.GetHumanName()@"!!! 5 BONUS frags!" );
          }
          else if (Other.isA('Warlord') )
          {
               Killer.playerreplicationinfo.score += 2;
               BroadcastMessage( Killer.PlayerReplicationInfo.PlayerName@deathmsg@"a Warlord !! 3 BONUS frags!" );
          }
          else
          {
               BroadcastMessage( Killer.PlayerReplicationInfo.PlayerName@deathmsg@Other.GetHumanName() );
          }
     }
  }
     if ( NextMutator != None )
          NextMutator.ScoreKill(Killer, Other);
}

function bool PreventDeath(Pawn Killed, Pawn Killer, name damageType, vector HitLocation)
{
     if (Killed.isA('Cow') || Killed.isA('LeglessKrall'))
     {
        HurtRadius(1000.0, 250.0, 'RedeemerDeath', 10000, Killed.Location );
        spawn(class'ShockWave',,,Killed.Location);
     }
     if ( NextMutator != None )
	   return NextMutator.PreventDeath(Killed,Killer, damageType,HitLocation);
      return false;
}

function string dmsg()
{
     local int msgtype;
     local string msgtext;

               msgtype=rand(23);
               switch(msgtype)
               {
               case 0:
                    msgtext = "took out";
                    break;
               case 1:
                    msgtext = "make short work of";
                    break;
               case 2:
                    msgtext = "just slaughtered";
                    break;
               case 3:
                    msgtext = "terminated";
                    break;
               case 4:
                    msgtext = "massacrated";
                    break;
               case 5:
                    msgtext = "violated";
                    break;
               case 6:
                    msgtext = "destroyed";
                    break;
               case 7:
                    msgtext = "obliterated";
                    break;
               case 8:
                    msgtext = "beat up";
                    break;
               case 9:
                    msgtext = "smashed";
                    break;
               case 10:
                    msgtext = "owned";
                    break;
               case 11:
                    msgtext = "gave a major ass-whooping to";
                    break;
               case 12:
                    msgtext = "provided a fatal dose of pain to";
                    break;
               case 13:
                    msgtext = "blowed up";
                    break;
               case 14:
                    msgtext = "fatally fucked up";
                    break;
               case 15:
                    msgtext = "mangled";
                    break;
               case 16:
                    msgtext = "recreationally abused";
                    break;
               case 17:
                    msgtext = "dismantled";
                    break;
               case 18:
                    msgtext = "assaulted";
                    break;
               case 19:
                    msgtext = "soiled himself and wept after murdering";
                    break;
               case 20:
                    msgtext = "executed";
                    break;
               case 21:
                    msgtext = "eliminated";
                    break;
               case 22:
                    msgtext = "murdered";
                    break;
               }
	return msgtext;
}

function Timer()
{
     do
     {
          stack_pull(SpreeType,Loc);
          SpawnBadGuy();
          if (sp != None)
          {
               mn = sp.GetHumanName();
               log("*** Timer Spawned " $ mn);
               BroadcastMessage("Monster alert:"  $ mn $ " detected !");
          }
     } until (stack_point == 0) ;
}


function MutatorTakeDamage( out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation,
     out Vector Momentum, name DamageType)
{
     if ((Instigatedby != None) && (InstigatedBy.IsA('Bot') || InstigatedBy.IsA('PlayerPawn')|| InstigatedBy.IsA('ScriptedPawn')))
     { 
          if (DamageType == 'Decapitated' && ActualDamage > Victim.Health)
          {
              stack_push(InstigatedBy.spree, Victim.Location);
              setTimer(1,false);
          }
          if (DamageType == 'Impact' && ActualDamage > Victim.Health)
          {
              stack_push(-1, Victim.Location);
              setTimer(1,false);
          }
     }  
     if ( NextDamageMutator != None )
          NextDamageMutator.MutatorTakeDamage( ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType );
}

function stack_push(int xxSpree, vector xxLoc)
{
     stack_spree[stack_point] = xxSpree;
     stack_loc[stack_point] = xxLoc;
     stack_point ++;
//     log("*** pushed sp=" $ stack_point $ " spree=" $ xxspree); 
}

function stack_pull(out int SpreeType, out vector Loc)
{
     stack_point --;
     SpreeType =     stack_spree[stack_point];
     Loc = stack_loc[stack_point];
     stack_spree[stack_point] = 0;
     stack_loc[stack_point] = vect(0,0,0);
//     log("*** pulled=" $ stack_point $ " spree=" $ SpreeType); 
}


// Spawn a monster, if monster can't be spawn try to fall back on a smaller one
function SpawnBadGuy()
{
     log("*** Attempting to spawn a monster");
     if (spreetype > 24)          //godlike 
     {
          monstertype=rand(3);
          switch(monstertype)
          {
          case 0:
               sp = spawn(class'unreali.Queen',,, loc);
               break;
          case 1:
               sp = spawn(class'unreali.Titan',,, loc);
               break;
          case 2:
               sp = spawn(class'unreali.StoneTitan',,, loc);
               break;
          }
          if (sp != none)
          {
               setupMonster(sp);
               return;
          }
     }
     if (spreetype > 19)          //unstoppable 
     {
          monstertype=rand(2);
          switch(monstertype)
          {
          case 0:
               sp = spawn(class'unreali.WarLord',,, loc);
               break;
          case 1:
               sp = spawn(class'unreali.Queen',,, loc);
               break;
          }
          if (sp != none)
          {
               setupMonster(sp);
               return;
          }
     }          
     if (spreetype > 14)          //dominating 
     {
          monstertype=rand(5);
          switch(monstertype)
          {
          case 0:
               sp = spawn(class'unreali.SkaarjScout',,, loc);
               break;
          case 1:
               sp = spawn(class'unreali.SkaarjWarrior',,, loc);
               break;
          case 2:
               sp = spawn(class'unreali.SkaarjAssassin',,, loc);
               break;
          case 3:
               sp = spawn(class'unreali.SkaarjLord',,, loc);
               break;
          case 4:
               sp = spawn(class'unreali.SkaarjBerserker',,, loc);
               break;
          }     
          if (sp != none)
          {
               setupMonster(sp);
               return;
          }
     }     
     if (spreetype > 9)          //rampage      
     {
          monstertype=rand(5);
          switch(monstertype)
          {
          case 0:
               sp = spawn(class'unreali.SkaarjSniper',,, loc);
               break;
          case 1:
               sp = spawn(class'unreali.SkaarjTrooper',,, loc);
               break;
          case 2:
               sp = spawn(class'unreali.SkaarjInfantry',,, loc);
               break;
          case 3:
               sp = spawn(class'unreali.SkaarjGunner',,, loc);
               break;
          case 4:
               sp = spawn(class'unreali.SkaarjOfficer',,, loc);
               break;
          }     
          if (sp != none)
          {
               setupMonster(sp);
               return;
          }
     }     
     if (spreetype > 4)           //killing spree 
     {
          monstertype=rand(4);
          switch(monstertype)
          {
          case 0:
               sp = spawn(class'unreali.Slith',,, loc);
               break;
          case 1:
               sp = spawn(class'unreali.KrallElite',,, loc);
               break;
          case 2:
               sp = spawn(class'unreali.MercenaryElite',,, loc);
               break;
          case 3:
               sp = spawn(class'unreali.Brute',,, loc);
               break;
          }     
          if (sp != none)
          {
               setupMonster(sp);
               return;
          }
     }
     if (spreetype > 0)           //any  
     {
          monstertype=rand(6);
          switch(monstertype)
          {
          case 0:
               sp = spawn(class'unreali.Brute',,, loc);
               break;
          case 1:
               sp = spawn(class'unreali.Fly',,, loc);
               if (sp != none) setupMonster(sp);
               break;
          case 2:
               sp = spawn(class'unreali.Manta',,, loc);
               if (sp != none) setupMonster(sp);
               break;
           case 3:
               sp = spawn(class'unreali.Krall',,, loc);
               break;
           case 4:
               sp = spawn(class'unreali.Mercenary',,, loc);
               break;
           case 5:
               sp = spawn(class'unreali.Pupae',,, loc);
               if (sp != none) setupMonster(sp);
               break;    
          }     
          if (sp != none)
          {
               setupMonster(sp);
               return;
          }
     }
     if (spreetype == -1)           // Hammer Damage  
     {
          monstertype=rand(4);
          switch(monstertype)
          {
          case 0:
               sp = spawn(class'unreali.Cow',,, loc);
               break;
          case 1:
               sp = spawn(class'unreali.Manta',,, loc);
               break;
          case 2:
               sp = spawn(class'unreali.Fly',,, loc);
               break;
          case 3:
               sp = spawn(class'unreali.Pupae',,, loc);
               break;     
          }     
          if (sp != none)
          {
               setupMonster(sp);
               return;
          }
     }
     if (sp == None)                                // last attempt to spawn something
     {              
          sp = spawn(class'unreali.Fly',,, loc);
          if (sp == None)                              // still no monster, too bad
          {
            log("*** Could not spawn a monster");
            return;
          }
	  else setupMonster(sp);
     }
     else
     {
          setupMonster(sp);
          return;
     }
}



function setupMonster(out scriptedpawn monster)
{
     local pawn aVictim;

     if ((monster.bHidden) || (!monster.bCollideActors))
     {
         log("Inviso monster destroyed.....");
         monster.Destroy(); return;
     }
//     Log("*** setupMonster Spawned " $ monster.GetHumanName());
//     Log("*** Health=" $ monster.health$"  CollideActors= "$monster.bCollideActors);
     monster.skill = 2;
     monster.bHunting=true;
     monster.health *= 2;
     monster.health = clamp(monster.health,120,1800);
     if (!monster.isA('Fly'))
	{
	     monster.bHateWhenTriggered=true;
	     monster.Intelligence=BRAINS_Human;
	     monster.bCanStrafe = True;
	     monster.CombatStyle = 1.0;
	}
     if (monster.isA('Warlord'))
        Warlord(monster).bTeleportWhenHurt = True;
}

defaultproperties
{
}
